import urllib
import urllib2
import cookielib
from PIL import Image
import time
from bs4 import BeautifulSoup as bse
import re

def eq(a,b):
    for i in range(10):
        for j in range(8):
            if a[i][j] != b[i][j]:
                return False
    return True

def getnum(impath):
    im = Image.open(impath).convert('L')
    aclist = [36,27,32,31,35,37,39,26,40,39]
    b = []
    x,y = im.size
    for hang in range(x):
        for num in range(y):
            b.append(im.getpixel((hang,num)))
    acnum = b.count(255)
    if acnum != 39:
        return aclist.index(acnum)
    elif im.getpixel((0,4)) == 255:
        return 6
    else:
        return 9
    
def crackim():
    ans = ''
    wmice = Image.open('im.png')
    for imnum in range(4):
        box = (1+9*imnum,3,9+9*imnum,13)
        wmice.crop(box).save('im'+str(imnum)+'.png')
    for i in range(4):
        ans += str(getnum('im'+str(i)+'.png'))
    return ans

header = {'User-Agent':'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.1.6) Gecko/20091201 Firefox/3.5.6'}
urlindex = 'http://ecard.ustc.edu.cn/sisms/index.php/login/index'
urllog = 'http://ecard.ustc.edu.cn/sisms/index.php/login/dologin'
urlim = 'http://ecard.ustc.edu.cn/sisms/index.php/login/getimgcode'
dealurl = 'http://ecard.ustc.edu.cn/sisms/index.php/person/deal'

def login(stunum,passw):
    cookiejar=cookielib.CookieJar()
    opener=urllib2.build_opener(urllib2.HTTPCookieProcessor(cookiejar))
    urllib2.install_opener(opener)
    opener.open(urlindex)
    
    reqim = opener.open(urlim).read()    
    with open('im.png','wb') as pic:
        pic.write(reqim)
    imcode = crackim()


    postdata = {
                    'username':stunum,
                    'password':passw,
                    'usertype':'1',
                    'schoolcode':'001',
                    'imgcode':imcode
                    }
    postdata = urllib.urlencode(postdata)                   
    req = urllib2.Request(urllog,postdata,headers = header)    
    rep = opener.open(req).read()
    if rep != '{"flag":1,"msg":"","data":""}':
        print '** YOU!!\nNOT CORRECT PASSWORD'
    return cookiejar


def ecardinfo(stunum,passw,startdate,enddate,filepath):
    cookiejar=login(stunum,passw)
    opener=urllib2.build_opener(urllib2.HTTPCookieProcessor(cookiejar))
    urllib2.install_opener(opener)

    pd = {
        'start_date':startdate,#'2015-01-01',
        'type':'',
        'end_date':enddate,
        'place':''
        }
    pd = urllib.urlencode(pd) 
    rq = urllib2.Request(dealurl,pd,headers = header)    
    res = str(opener.open(rq).read())

    ana = bse(res)
    pages = int(re.sub(dealurl+'/','',ana.find_all('a')[-1].get('href')))/10 + 1

    for i in range(pages):
        furl = dealurl + '/' + str(i*10)
        info = str(opener.open(furl).read())
        bsinfo = bse(info)
        bstr = bsinfo.find('tbody').find_all('tr')
        for tr in bstr:
            td = tr.find_all('td')
            dtime = td[1].get_text()
            dloca = td[2].get_text()
            with open(filepath,'a') as jl:
                jl.write(dtime + '\n')
                jl.write(dloca.encode('utf-8') + '\n')

    return True

def getph(stunum,passw,filename):
    cookiejar=login(stunum,passw)
    opener=urllib2.build_opener(urllib2.HTTPCookieProcessor(cookiejar))
    urllib2.install_opener(opener)
    purl = 'http://ecard.ustc.edu.cn/sisms/index.php/person/getphoto'

    with open(filename + '.jpg','wb') as db:
        db.write(opener.open(purl).read())
    
    
        

